// The class describing each row in the sparse matrix.

#ifndef __ROW_H__
#define __ROW_H__

#include <list.h>
#include <iostream.h>
#include "node.h"

using namespace std;

template < class T >
class row {
public:
	//constructors & destructor
	row();
	~row();

	row< T > operator +(const row< T >& that);	// add another row, return the
										// reference of the result row (new)
	//row& operator -( const row& );	// subtract another row, return the
										// reference of the result row (new)
	//node& operator *( const col& );	// multiply with a column, the return 
										// type is an object of class node
	//void insert( node& );

	list< T > nLst;
// static:
	//spMat	spm;		// The Sparse Matrix 

};

// constructors and destructor
template < class T >
row< T >::row()
{
}

template < class T >
row< T >::~row()
{
    /* list< T >::iterator it;
    T temp;
    for(it = nLst.begin(); it!= nLst.end(); it++) {
        temp = *it;
        delete temp;
    } */
}

template < class T >
row< T > row< T >:: operator +( const row< T >& that )
{
    row < T >   result; 

    list< T >::iterator it0, it1;

    T   temp0, temp1;

    // Initialize the indices for this row and another row to be added.
    // it0 is for this row and it1 is for another row.
    it0 = nLst.begin();
    it1 = that.nLst.begin();

    // The following loop looks for the nodes in two rows whose column
    // numbers are identical, and add their values, if result is non-zero
    // value, add a new node into the result row.
    while( it0 != nLst.end() && it1 != that.nLst.end() ) {

        temp0 = <T> *it0;
        temp1 = <T> *it1;

        if( temp0.colNumber() < temp1.colNumber() ) {
            result.nLst.push_back(new T (temp0));
            it0++;
            continue;
        } else if( temp0.colNumber() == temp1.colNumber() ) {
            if( temp0 + temp1 != 0 ) {
                result.nLst.push_back( new node(temp0.rowNumber(),
                                                temp0.colNumber(),
                                                temp0 + temp1 ) );
            }
            it0++;  it1++;
            continue;
        } else {
            result.nLst.push_back(new T( temp1 ));
            it1++;
            continue;
        }
    }

    // If all the nodes of one row were accessed,
    // while some elements in the other row were left
    // copy the rest of the the element to the result row.
    while ( it0 != nLst.end() ) {
        temp0 = *it0;
        node newNode = temp0;
        newNode.setVal( temp0.getVal() );
        result.nLst.push_back( newNode );
        it0++;
    }

    while ( it1 != that.nLst.end() ){
        temp1 = *it1;
        node newNode = new node(temp1);
        newNode.setVal( temp1.getVal() );
        result.nLst.push_back( newNode );
        it1++;
    }

    return result;

}
//row row::sub( row );
//node row::mul( col );

#endif
